package com.qmth.jkserver.model;

//import java.util.Date;
//
//import org.springframework.data.annotation.Id;
//import org.springframework.data.mongodb.core.index.CompoundIndex;
//import org.springframework.data.mongodb.core.index.CompoundIndexes;
//import org.springframework.data.mongodb.core.index.Indexed;
//import org.springframework.data.mongodb.core.mapping.Document;
//import org.springframework.data.mongodb.core.mapping.Field;
//
///**
// * 存储考场监控信息
// * @author tianjun
// *
// */
//@Document(collection = "jk_exam_room_monitor_info")
//@CompoundIndexes({ @CompoundIndex(name = "jk_exam_room_monitor_info_idx", def = "{'exam_code':1,'place_code': 1, 'room_code': 1}") })
//public class ExamRoomMonitorInfo {
//
//	@Id
//	private String id;
//
//	@Indexed
//	@Field("exam_code")
//	private String examCode;
//
//	@Field("place_code")
//	private String placeCode;
//
//	@Field("room_code")
//	private String roomCode;
//
//	@Field("course_code")
//	private String courseCode;
//
//	@Field("login_count")
//	private Long loginCount;
//
//	@Field("contact_error_count")
//	private Long contactErrorCount;
//
//	/**
//	 * 创建时间
//	 */
//	@Field("create_time")
//	private Date createTime;
//
//	/**
//	 * @return the loginCount
//	 */
//	public Long getLoginCount() {
//		return loginCount;
//	}
//
//	/**
//	 * @param loginCount the loginCount to set
//	 */
//	public void setLoginCount(Long loginCount) {
//		this.loginCount = loginCount;
//	}
//
//	/**
//	 * @return the contactErrorCount
//	 */
//	public Long getContactErrorCount() {
//		return contactErrorCount;
//	}
//
//	/**
//	 * @param contactErrorCount the contactErrorCount to set
//	 */
//	public void setContactErrorCount(Long contactErrorCount) {
//		this.contactErrorCount = contactErrorCount;
//	}
//
//	/**
//	 * @return the courseCode
//	 */
//	public String getCourseCode() {
//		return courseCode;
//	}
//
//	/**
//	 * @param courseCode the courseCode to set
//	 */
//	public void setCourseCode(String courseCode) {
//		this.courseCode = courseCode;
//	}
//
//	/**
//	 * @return the id
//	 */
//	public String getId() {
//		return id;
//	}
//
//	/**
//	 * @param id the id to set
//	 */
//	public void setId(String id) {
//		this.id = id;
//	}
//
//	/**
//	 * @return the examCode
//	 */
//	public String getExamCode() {
//		return examCode;
//	}
//
//	/**
//	 * @param examCode the examCode to set
//	 */
//	public void setExamCode(String examCode) {
//		this.examCode = examCode;
//	}
//
//	/**
//	 * @return the placeCode
//	 */
//	public String getPlaceCode() {
//		return placeCode;
//	}
//
//	/**
//	 * @param placeCode the placeCode to set
//	 */
//	public void setPlaceCode(String placeCode) {
//		this.placeCode = placeCode;
//	}
//
//	/**
//	 * @return the roomCode
//	 */
//	public String getRoomCode() {
//		return roomCode;
//	}
//
//	/**
//	 * @param roomCode the roomCode to set
//	 */
//	public void setRoomCode(String roomCode) {
//		this.roomCode = roomCode;
//	}
//
//	/**
//	 * @return the createTime
//	 */
//	public Date getCreateTime() {
//		return createTime;
//	}
//
//	/**
//	 * @param createTime the createTime to set
//	 */
//	public void setCreateTime(Date createTime) {
//		this.createTime = createTime;
//	}
//}

import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;

/**
 * <p>
 * 存储考场监控信息
 * </p>
 *
 * @author wangliang
 * @since 2023-03-01
 */
@ApiModel(value="JkExamRoomMonitorInfo对象", description="存储考场监控信息")
@TableName("jk_exam_room_monitor_info")
public class ExamRoomMonitorInfo implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "主键")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long id;

    @ApiModelProperty(value = "考试编码")
    private String examCode;

    @ApiModelProperty(value = "地方编码")
    private String placeCode;

    @ApiModelProperty(value = "考场编码")
    private String roomCode;

    @ApiModelProperty(value = "科目编码")
    private String courseCode;

    @ApiModelProperty(value = "登记次数")
    private Integer loginCount;

    @ApiModelProperty(value = "联系错误次数")
    private Integer contactErrorCount;

    @ApiModelProperty(value = "创建时间")
    private Long createTime;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getExamCode() {
        return examCode;
    }

    public void setExamCode(String examCode) {
        this.examCode = examCode;
    }

    public String getPlaceCode() {
        return placeCode;
    }

    public void setPlaceCode(String placeCode) {
        this.placeCode = placeCode;
    }

    public String getRoomCode() {
        return roomCode;
    }

    public void setRoomCode(String roomCode) {
        this.roomCode = roomCode;
    }

    public String getCourseCode() {
        return courseCode;
    }

    public void setCourseCode(String courseCode) {
        this.courseCode = courseCode;
    }

    public Integer getLoginCount() {
        return loginCount;
    }

    public void setLoginCount(Integer loginCount) {
        this.loginCount = loginCount;
    }

    public Integer getContactErrorCount() {
        return contactErrorCount;
    }

    public void setContactErrorCount(Integer contactErrorCount) {
        this.contactErrorCount = contactErrorCount;
    }

    public Long getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Long createTime) {
        this.createTime = createTime;
    }
}

